//---------------------------------------------------------------------------

#include <vcl.h>
#include <windows.h>
#pragma hdrstop
#include "Params.h"

#define DLLEXPORT __stdcall __declspec(dllexport)

#pragma argsused
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void* lpReserved)
{
    if (reason == DLL_PROCESS_ATTACH) // Raison d'appel
    {
        return 1;
    }
    else
    {
        return 0;
    }
}
//---------------------------------------------------------------------------
extern "C" PPluginLanguage DLLEXPORT RegisterPluginLanguage();
extern "C" PPluginHeader DLLEXPORT RegisterPluginHeader();
extern "C" PPluginStruct DLLEXPORT RegisterPluginStruct();
extern "C" int DLLEXPORT RegisterCompatibility();
extern "C" void DLLEXPORT SetColorPicker(TDColor Color);
extern "C" int DLLEXPORT Execute();
//---------------------------------------------------------------------------
extern "C" PPluginLanguage DLLEXPORT RegisterPluginLanguage()
{
    return &PluginLanguage;
}
//---------------------------------------------------------------------------
extern "C" PPluginHeader DLLEXPORT RegisterPluginHeader()
{
    SetHeaderCaption("Test ColorPicker2...");
    SetHeaderVersion("1.1");
    SetHeaderPluginType(ptFilter);
    SetHeaderAuthor("Antonio DA CRUZ");
    SetHeaderComment("Plugin d''exemple pour PhotoFiltre !");
    return &PluginHeader;
}
//-------------------------------------------------------------------------
extern "C" PPluginStruct DLLEXPORT RegisterPluginStruct()
{
    return &PluginStruct;
}
//-------------------------------------------------------------------------
extern "C" int DLLEXPORT RegisterCompatibility()
{
    return NON_DELPHI;
}
//-------------------------------------------------------------------------
void RegisterApplication()
{
    Application->Handle=(void*)MainHandle();
}
//-------------------------------------------------------------------------
extern "C" void DLLEXPORT SetColorPicker(TDColor Color)
{
    ParamsForm->PnlColor->Color=Color;
}
//-------------------------------------------------------------------------
extern "C" int DLLEXPORT Execute()
{
    char Code[3];

    try
    {
        RegisterApplication();
        ParamsForm=new TParamsForm(Application);
        ParamsForm->Caption=ParamsForm->Caption.cat_sprintf(" %s (%s)", GetLanguageStr(), GetLanguageCode(Code));
        try
        {
            ParamsForm->Show();
            PrepareDialog(ParamsForm->Handle, doColorPicker, true, true);
            return ParamsForm->DialogResult;
        }
        __finally
        {
            delete ParamsForm;
        }
    }
    catch(...)
    {
        return 0;
    }
}
//-------------------------------------------------------------------------

